/* Clip.c - Clip samples to specified plus and minus peak values
 * Uses SSE2 - requires a Pentium 4 or later
 * Copyright March 2009 Phil Karn, KA9Q
 * May be used under the terms of the GNU General Public License (GPL)
 *
 * $Id$
 */

#include "dspfec.h"

void clip_p(signed short *,int,int,int);
void clip_sse2(signed short *,int,int,int);

void clip(signed short *b,int cnt,int maxval,int minval){
  if(Cpu_features == UNKNOWN)
    cpu_id();

  switch(Cpu_features){
#if __i386__ || __x86_64__
  case SSE2:
    clip_sse2(b,cnt,maxval,minval);
    break;
#endif
  default:
    clip_p(b,cnt,maxval,minval);
    break;
  }
}


void clip_p(signed short *b,int cnt,int maxval,int minval){
  if(maxval < minval){
    /* Swap */
    int tmp;
    tmp = minval;
    minval = maxval;
    maxval = tmp;
  }
  if(maxval > 32767)
    maxval = 32767;
  if(minval < -32767)
    minval = -32767; /* Note: -32768 (0x8000) is always clipped */

  /* Mop up the end, or do the whole thing if we don't have SSE2 */
  while(cnt > 0){
    if(*b > maxval){
      *b = maxval;
    } else if(*b < minval) {
      *b = minval;
    }
    b++;
    cnt--;
  }
}

