#include "sse.h"
#if !defined(__SSE2__)
#error "Must compile with -msse2 or better"
#endif

void clip_sse2(signed short *b,int cnt,int maxval,int minval){
  if(maxval < minval){
    /* Swap */
    int tmp;
    tmp = minval;
    minval = maxval;
    maxval = tmp;
  }
  if(maxval > 32767)
    maxval = 32767;
  if(minval < -32767)
    minval = -32767; /* Note: -32768 (0x8000) is always clipped */

  /* Handle anything ahead of the first 16-byte boundary */
  while(cnt > 0 && ((long)b & 0xf) != 0){
    if(*b > maxval){
      *b = maxval;
    } else if(*b < minval) {
      *b = minval;
    }
    b++;
    cnt--;
  }
  /* b is now aligned on a 16-byte boundary */
  {
    v8hi maxv,minv,*buffer;
    
    if(cnt >= 8){
      maxv = (v8hi)_mm_set_epi16(maxval,maxval,maxval,maxval,maxval,maxval,maxval,maxval);
      minv = (v8hi)_mm_set_epi16(minval,minval,minval,minval,minval,minval,minval,minval);

      /* This seems to produce the best code with gcc -O6 */
      for(buffer = (v8hi *)b;buffer < (v8hi *)&b[cnt & ~7];buffer++){
	*buffer = (v8hi)_mm_min_epi16(maxv,*buffer);
	*buffer = (v8hi)_mm_max_epi16(minv,*buffer);
      }
    }
  }
  /* Mop up the end, or do the whole thing if we don't have SSE2 */
  while(cnt > 0){
    if(*b > maxval){
      *b = maxval;
    } else if(*b < minval) {
      *b = minval;
    }
    b++;
    cnt--;
  }
}
