#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "dspfec.h"

long long dotprod_ref(signed short *c,signed short *in,int cnt);

int main(){
  void *dp;
  short coeffs[512],input[512];
  int i,trial,subtrial;
  long long t,r;
  int l;
  int errors = 0;
  double gain;

  cpu_id();
  srandom(time(NULL));

  for(trial=0;trial<10000;trial++){
    gain = 0;
    for(i=0;i<512;i++){
      coeffs[i] = random();
      gain += abs(coeffs[i]);
    }
    gain = 65535./gain;
    //    printf("gain = %lg\n",gain);
    for(i=0;i<512;i++)
      coeffs[i] *= gain;

    dp = initdp(coeffs,512);
    for(subtrial=0;subtrial<10;subtrial++){
      for(i=0;i<512;i++)
	input[i] = random();
      r = dotprod_ref(coeffs,input,512);
      t = dotprodl(dp,input);
      l = dotprod(dp,input);

      if(t != r){
	printf("dotprodl result %lld (%llx) != reference result %lld (%llx)\n",t,t,r,r);
	errors++;
      }
      /* Compare only low 32 bits from dotprod() */
      if((l ^ r) & 0xffffffff){
	printf("dotprod result %d (%x) != reference result %lld (%llx) in low 32 bits\n",l,l,r,r);
	errors++;
      }
    }
  }
  if(errors == 0){
    printf("Dot product OK, %d trials\n",trial);
    exit(0);
  } else {
    printf("Dot product FAIL, %d errors in %d trials\n",errors,trial);
    exit(1);
  }
}

long long dotprod_ref(signed short *c,signed short *in,int cnt){
  int i;
  long long s = 0;

  for(i=0;i<cnt;i++){
    s += (long long)c[i] * in[i];
  }
  return s;
}

