#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "dspfec.h"

void int2short_p(signed short *,signed int *,int);
void int2short_sse2(signed short *,signed int *,int);
void char2short_p(signed short *,signed char *,int);
void char2short_sse2(signed short *,signed char *,int);

int main(){
  signed int *input_int;
  signed short *output_short1,*output_short2;
  int i;
  int n = 20480000;
  signed char *input_char;

  cpu_id();
  
  input_int = malloc(n*sizeof(*input_int));
  assert(input_int != NULL);
  output_short1 = malloc(n*sizeof(*output_short1));
  assert(output_short1 != NULL);
  output_short2 = malloc(n*sizeof(*output_short1));
  assert(output_short2 != NULL);
  for(i=0;i<n;i++){
    output_short1[i] = 0xbeef;
    output_short2[i] = 0xdead;
  }

  for(i=0;i<n;i++){
    int x,y;
    x = random();
    y = random();
    if(y & 1)
      x = -x; // give x a random sign bit
    input_int[i] = abs(x) > 1000000000 ? x : (short)x ;
  }

  int2short_p(output_short1,input_int,n);
  int2short_sse2(output_short2,input_int,n);
  for(i=0;i<n;i++){
    if(output_short1[i] != output_short2[i])
      printf("%d: %10x -> %5x %5x\n",i,input_int[i],output_short1[i],output_short2[i]);
  }
  free(input_int);

  input_char = malloc(n*sizeof(*input_char));
  assert(input_char != NULL);
  for(i=0;i<n;i++){
    output_short1[i] = 0xbeef;
    output_short2[i] = 0xdead;
  }
  for(i=0;i<n;i++){
    int x;

    x = i & 0xff;
    input_char[i] = x;
  }
  char2short_p(output_short1,input_char,n);
  char2short_sse2(output_short2,input_char,n);
  for(i=0;i<n;i++){
    if(output_short1[i] != output_short2[i])
      printf("%d: %2x -> %5x %5x\n",i,input_char[i],output_short1[i],output_short2[i]);
  }
  

  exit(0);
}
