/* Parity test routines
 *
 * $Id$
 */

#include <stdio.h>
#include "dspfec.h"

#define POLY 0xd800000000000000LL
#define TRIALS 100000000LL

static inline int parity_slow(unsigned long long x){
  x ^= x >> 32;
  x ^= x >> 16;
  x ^= x >> 8;
  x ^= x >> 4;
  x ^= x >> 2;
  x ^= x >> 1;
  return x & 1;
}



int main(){
  unsigned long long lfsr = 1;
  unsigned long long trials;

  for(trials=0;trials<TRIALS;trials++){
    //    printf("%016llx\n",lfsr);
    if(parityl(lfsr) != parity_slow(lfsr)){
      printf("parity test failed at %llx after %lld trials\n",lfsr,trials);
      return 1;
    }
    lfsr = (lfsr >> 1) ^ (-(lfsr & 1) & POLY);
    if(lfsr == 1)
      break;
  }
  printf("Parity functions OK, %lld trials\n",TRIALS);
  return 0;
}
