
/* Verify correctness of the peak routine
 * $Id$
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "dspfec.h"

/* These values should trigger leading/trailing array fragment handling */
#define NSAMP 200002
#define OFFSET 1

int peakval(signed short *,int);
int peakval_ref(signed short *,int);

signed short samples[NSAMP];
#define TRIALS 200

int main(){
  int i,s,t;
  int result,rresult;
  int errors = 0;

  cpu_id();
  srandom(time(NULL));

  for(t=0;t<TRIALS;t++){
    for(i=0;i<NSAMP;i++){
      do {
	s = random() & 0xffff;
      } while(s == 0x8000); /* Can't handle this value yet */
      samples[i] = s;
    }
    
    rresult = peakval_ref(&samples[OFFSET],NSAMP-OFFSET);
    result = peakval(&samples[OFFSET],NSAMP-OFFSET);
    if(result != rresult){
      errors++;
      printf("peak mismatch: %d != %d\n",result,rresult);
      for(i=OFFSET;i<NSAMP-OFFSET;i++){
	printf(" %05d",samples[i]);
	if((i % 16) == 0){
	  printf("\n");
	}
      }
    }
  }
  printf("Peak test done, %d errors in %d trials\n",errors,TRIALS);
  if(errors)
    return 1;
  else
    return 0;
}

int peakval_ref(signed short *b,int cnt){
  int peak = 0;
  int a,i;

  for(i=0;i<cnt;i++){
    a = abs(b[i]);
    if(a > peak)
      peak = a;
  }
  return peak;
}

