/* Peakval.c - Find and return the 16-bit word with the largest absolute value in buffer
 * Uses SSE2 - requires a Pentium 4 or later
 * Currently ignores sample values of -32768 (0x8000); fix this?
 * 
 * Copyright March 2009 Phil Karn, KA9Q
 * May be used under the terms of the GNU General Public License (GPL)
 *
 * $Id$
 */

#include <stdlib.h>
#include "dspfec.h"

int peakval_p(signed short *,int);
int peakval_sse2(signed short *,int);

int peakval(signed short *b,int cnt){
  if(Cpu_features == UNKNOWN)
    cpu_id();

  switch(Cpu_features){
#if __i386__ || __i486__ || __i586__|| __i686__ || __x86_64__
  case SSE2:
    return peakval_sse2(b,cnt);
    break;
#endif
  default:
    return peakval_p(b,cnt);
    break;
  }
}

int peakval_p(signed short *b,int cnt){
  int peak = 0,i;

  for(i=0;i<cnt;i++){
    if(abs(b[i]) > peak)
      peak = abs(b[i]);
  }
  return peak;
}


