/* Test normal random number generator
 * $Id$
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include "dspfec.h"

#define TRIALS 30000000


int main(){
  long calls = 0;
  double sumsquares = 0;
  double sum = 0;
  long i;
  float r;
  long zerosigma = 0;
  long onesigma = 0;
  long twosigma = 0;
  long threesigma = 0;
  long foursigma = 0;
  double x;
  
  srandom(time(NULL));
  zigset(time(NULL));
  /*
    speeds: rnor, 64 bits: .0626 microsec
    normal_rand, 64 bits: .1004 microsec
    normal_rand, 32 bits: .1641 microsec
    rnor, 32 bits: .0180 microsec
    rnor, 64 bits, long->int: .0117 microsec
   */
  for(i=0;i<TRIALS;i++){
    r = rnor();
    //r = normal_rand();

    calls++;
    sum += r;
    sumsquares += r*r;
    if(r <= 4){
      foursigma++;
      if(r <= 3){
	threesigma++;
	if(r <= 2){
	  twosigma++;
	  if(r <= 1){
	    onesigma++;
	    if(r <= 0){
	      zerosigma++;
	    }
	  }
	}
      }
    }
  }
  printf("Calls %ld average %.10g RMS %.10g\n0 sigma %ld; 1 sigma %ld; 2 sigma %ld; 3 sigma %ld; 4 sigma %ld\n",
	 calls,sum/calls,sqrt(sumsquares/calls),
	 zerosigma,onesigma,twosigma,threesigma,foursigma);
  for(x = 0;x < 5;x += 1.0){
    printf("cdf(%g) = %g\n",x,0.5 + 0.5*erf(x/M_SQRT2));
  }
  exit(0);

}
