/* Verify correctness of the sum-of-square routines
 * Phil Karn, KA9Q, April 2009
 * $Id$
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include "dspfec.h"

/* These values should trigger leading/trailing array fragment handling */
#define NSAMP 200002
#define OFFSET 1

#define TRIALS 2000


long long sumsq_wq_ref(signed short *in,int cnt);

int main(){
  int i;
  long long result,rresult;
  signed short samples[NSAMP];
  int trials;
  int errors=0;
  int offset;
  int nsamp;
  long long grand_total = 0;
  int grand_samples = 0;

  cpu_id();
  srandom(time(NULL));

  for(trials=0;trials<TRIALS;trials++){
    offset = random() % 32;
    nsamp = random() % NSAMP;

    for(i=0;i<nsamp;i++)
	samples[i] = random();

    rresult = sumsq_wq_ref(&samples[offset],nsamp-offset);
    result = sumsq(&samples[offset],nsamp-offset);
    grand_total += result;
    grand_samples += nsamp-offset;
    if(result != rresult){
      errors++;
      printf("sum mismatch: %lld != %lld\n",result,rresult);
      printf("offset = %d nsamp = %d\n",offset,nsamp);
      for(i=offset;i<nsamp-offset;i++){
	printf(" %05d",samples[i]);
	if((i % 16) == 0){
	  printf("\n");
	}
      }
    }
  }
#if 0
  printf("total sum %lld samples %d RMS %.1lf\n",grand_total,grand_samples,sqrt((double)grand_total/grand_samples));
#endif
  if(errors == 0){
    printf("PASS, %d trials\n",trials);
    exit(0);
  } else {
    printf("FAIL: %d errors in %d trials\n",errors,trials);
    exit(1);
  }
}

long long sumsq_wq_ref(signed short *in,int cnt){
  long long sum = 0;
  int i;

  for(i=0;i<cnt;i++){
    sum += (long)in[i] * in[i];
  }
  return sum;
}

