#include <stdlib.h>
#include "dspfec.h"

unsigned long long sumsq_p(signed short *,int);
unsigned long long sumsq_sse2(signed short *,int);
unsigned long long sumsq_av(signed short *,int);

unsigned long long sumsq(signed short *b,int cnt){
  if(Cpu_features == UNKNOWN)
    cpu_id();

#if __i386_ || __i486__ || __i586__ || __i686__ || __x86_64__
  if(Cpu_features >= SSE2)
    return sumsq_sse2(b,cnt);
#elif __ppc__
  if(Cpu_features >= ALTIVEC)
    return sumsq_av(b,cnt);
#endif
    return sumsq_p(b,cnt);
}

/* Sum of squares of 16-bit signed integers - useful for energy measurement
 * Portable C version
 * Copyright 2009 Phil Karn, KA9Q
 * May be used under the terms of the GNU Public License (GPL)
 *
 * $Id$
 */
unsigned long long sumsq_p(signed short *in,int cnt){
  unsigned long long sum;
  int i;

  sum = 0;
  for(i=0;i<cnt;i++)
    sum += (long)in[i] * in[i];

  return sum;
}

