// Wide version of k=7 r=1/2 Viterbi decoder that uses 16-bit path metrics instead of 8 bits
// Only the path metrics are wider; the decisions are still packed to 64 bits, and the branch table entries are 8 bits each
typedef union { signed short w[64]; v8hi v[8]; } metric_sse2_t;
typedef union { unsigned char c[8]; unsigned short w[4]; } decision_sse2_t;
union branchtab27_sse2w { unsigned short s[32]; v16qi v[2];} Branchtab27_sse2[2];

/* State info for instance of Viterbi decoder */
struct v27sse2 {
  metric_sse2_t metrics1,metrics2;
  metric_sse2_t *old_metrics; /* path metric buffer */
  metric_sse2_t *new_metrics;
  decision_sse2_t *dp;          /* Pointer to current decision */
  int length;             /* Length of decision array, bits */
  int magic;
  /* Decision array follows this header */
};

#define V27MAGIC 0x0102fffe

